/* 
   Actor.h

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#ifndef _ACTOR_H_
#define _ACTOR_H_

#include "IceCreamCone.h"
#include "Object.h"

class Actor : public Object
{
 public:
  Actor();
  virtual ~Actor();

  /**
   * make the character run
   */
  void run();
  /**
   * draw the actor and it's code
   */
  virtual void draw();
  /**
   * handle the input
   */
  void handleInput();
  /**
   * see if we caught the ice cream
   */
  void checkIceCreamCollision(vector < IceCreamScoop * > *scoops);

  /**
   * set the keys, up down left and right
   */
  void setKeys(int up, int down, int left, int right);

  /**
   * get a reference to the icecream cone
   */
  IceCreamCone *getCone() { return _iceCreamCone; }

 protected:
  IceCreamCone *_iceCreamCone;

  // for keypresses
  int _keyUp, _keyDown, _keyLeft, _keyRight;
};

#endif
