/* 
   FrameRate.cpp

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#include "FrameRate.h"

double CalculateFrameRate()
{
  static double framesPerSecond = 0.0;
  static double lastTime = 0.0;
  static double frameTime = 0.0;
  
  double currentTime;
  double frameInterval;
  
  // get the current time
  currentTime = SDL_GetTicks() * 0.001;
  
  // find the elapsed time, between the curren time and last time
  frameInterval = currentTime - frameTime;
  frameTime = currentTime;
  
  // increase the frames per second
  ++framesPerSecond;
  
  if (currentTime - lastTime > 1.0)
  {
    cout << "fps: " << framesPerSecond << endl;
    lastTime = currentTime;
    framesPerSecond = 0.0;
  }
  
  return frameInterval;
}

bool CalculateFrameRate2(double t)
{
  static double framesPerSecond = 0.0;
  static double lastTime = 0.0;
  static double frameTime = 0.0;
  
  double currentTime;
  double frameInterval;
  
  // get the current time
  currentTime = SDL_GetTicks() * 0.001;
  
  // find the elapsed time, between the curren time and last time
  frameInterval = currentTime - frameTime;
  frameTime = currentTime;
  
  // increase the frames per second
  ++framesPerSecond;
  
  if (currentTime - lastTime > t)
  {
    //cout << "fps: " << framesPerSecond << endl;
    lastTime = currentTime;
    //framesPerSecond = 0.0;
    return true;
  }
  
  return false;
}
