/* 
   IceCreamCone.cpp

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#include "IceCreamCone.h"

IceCreamCone::IceCreamCone()
  : Object()
{
  loadMesh("mesh/IceCreamCone.jbm");
}

IceCreamCone::~IceCreamCone()
{
  for (int i = 0; i < _iceCreamScoops.size(); i++)
    delete _iceCreamScoops[i];
}

/**
 * draw the cone and it's scoops
 */
void IceCreamCone::draw()
{
  // disable backface culling
  glDisable(GL_CULL_FACE);
  _mesh->draw();
  glEnable(GL_CULL_FACE);

  // translate the scoops to the cone
  for (int i = 0; i < _iceCreamScoops.size(); i++)
    _iceCreamScoops[i]->draw();
}

/**
 * add an icecream scoop to the cone
 */
void IceCreamCone::addIceCreamScoop(IceCreamScoop *i) 
{ 
  // stack the scoops
  i->setInitialPosition(Vector3(0.0, _iceCreamScoops.size() * 0.26 + 0.5, 0.0));
  _iceCreamScoops.push_back(i); 
}
