/* 
   IceCreamScoop.h

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#ifndef _ICECREAMSCOOP_H_
#define _ICECREAMSCOOP_H_

#include "Object.h"
#include "Timer.h"

class IceCreamScoop : public Object
{
 public:
  IceCreamScoop();
  virtual ~IceCreamScoop();

  /**
   * draw
   */
  virtual void draw();

  /**
   * calculate how far to fall
   */
  void fall();

  void hasShadow(bool t) { _hasShadow = t; }
  bool isDone() { return _done; }

 protected:
  Vector3 _color;

  /**
   * how fast the ice cream
   *  falls
   */
  float _speed;
  /**
   * does this have
   *  a shadow ?
   */
  bool _hasShadow;
  double _shadowSize;

  /**
   * special squashed mesh
   */
  SuperModel *_squashedMesh;
  bool _squashed;
  SuperModel *_drawMesh;

  /**
   * is the ice cream finished
   */
  bool _done;

  /**
   * timer for how long the squashed scoop should stay
   */
  Timer _timer;
};

#endif
