/* 
   ObjectFactory.cpp

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#include "ObjectFactory.h"

ObjectFactory::ObjectFactory()
{
  _ufTexture = new UserFunctionTexture();
}

ObjectFactory::~ObjectFactory()
{
  map < string, SuperModel * > ::iterator it;
  for (it = _meshes.begin(); it != _meshes.end(); it++)
  {
    delete (it->second);
  }
  if (_ufTexture)
    delete _ufTexture;
}

ObjectFactory *ObjectFactory::getInstance()
{
  static ObjectFactory instance;

  return &instance;
}

SuperModel *ObjectFactory::loadMesh(string filename)
{
  SuperModel *m = 0;
  m = _meshes[filename];

  if (m)
    return m;
  else
  {
    cout << "Creating new: " << filename << endl;
    m = new SuperModel(jb::STATIC, _ufTexture);
    m->AddMesh(filename);
    _meshes[filename] = m;
  }
  return m;
}
