/* 
   SuperModel.cpp

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#include "SuperModel.h"

Texture UserFunctionTexture::t;

SuperModel::SuperModel(jb::ModelType type, jb::UserFunction *fp)
  : Model(type, fp)
{
}

SuperModel::~SuperModel()
{

}

void SuperModel::draw()
{
  // reset the color
  //glColor4f(1.0, 1.0, 1.0, 1.0);
  // enable texturing
  glEnable(GL_TEXTURE_2D);

  for (unsigned int mesh = 0; mesh < bindMesh.size(); mesh++)
  {
    for (unsigned int i = 0; i < bindMesh[mesh]->numSurfaces; i++)
    {
      glBindTexture(GL_TEXTURE_2D, (unsigned int)(bindMesh[mesh]->surfaces[i].userData));
      for (unsigned int j = 0; j < bindMesh[mesh]->surfaces[i].numFaces; j++)
      {
	glBegin(GL_POLYGON);
	for (unsigned int k = 0; k < bindMesh[mesh]->surfaces[i].faces[j].numIndices; k++)
	{
	  if (type == jb::DEFORMABLE)
	  {
	    unsigned int index = bindMesh[mesh]->surfaces[i].faces[j].indices[k];
	    jb::SuperVertex *next = &(*nextMesh)[mesh]->surfaces[i].superVerts[index];
	    jb::SuperVertex *prev = &(*previousMesh)[mesh]->surfaces[i].superVerts[index];
	    glTexCoord2f(bindMesh[mesh]->surfaces[i].superVerts[index].u, bindMesh[mesh]->surfaces[i].superVerts[index].v);
	    glNormal3f(prev->a*(1-timeweight) + next->a*timeweight,
		       prev->b*(1-timeweight) + next->b*timeweight,
		       prev->c*(1-timeweight) + next->c*timeweight);
	    glVertex3f(prev->x*(1-timeweight) + next->x*timeweight,
		       prev->y*(1-timeweight) + next->y*timeweight,
		       prev->z*(1-timeweight) + next->z*timeweight);
	  }
	  else
	  {
	    jb::SuperVertex *svert = &bindMesh[mesh]->surfaces[i].superVerts[bindMesh[mesh]->surfaces[i].faces[j].indices[k]];

	    glTexCoord2f(svert->u, svert->v);
	    glNormal3f(svert->a, svert->b, svert->c);
	    glVertex3f(svert->x, svert->y, svert->z);
	  }
	}
	glEnd();
      }
    }
  }
}
