/* 
   Texture.h

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#ifndef _TEXTURE_H_
#define _TEXTURE_H_

#include <string>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

#include <GL/gl.h>
#include <GL/glu.h>

#include "SDL.h"
#include "SDL_image.h"

class Texture
{
 public:
  Texture();
  virtual ~Texture();

  /**
   * Create a texture from a filename
   */
  GLuint createTexture(string textureName);

 protected:
  /**
   * Function to swap texture from 2d to 3d coordinates
   */
  void swap(unsigned char &a, unsigned char &b);
  
  // Texture variables
  GLuint _textureList[100]; // 100 max per object
  int _numTextures;

  vector < string > _textureNames;
};

#endif
