/* 
   Vector2.cpp

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#include "Vector2.h"

Vector2::Vector2()
{
  for (int i = 0; i < 2; i++)
    _points[i] = 0.0;
}

Vector2::Vector2(double u, double v)
{
  _points[0] = u; _points[1] = v;
}

Vector2::Vector2(double *points)
{
  for (int i = 0; i < 2; i++)
    _points[i] = points[i];
}

Vector2::~Vector2()
{

}

ostream &operator<<(ostream &out, Vector2 &a) 
{
  out << a.getU() << ", " << a.getV();
  return out;
}

// overloaded operators
Vector2 Vector2::operator+(Vector2 v1)
{
  return Vector2(v1.getU() + _points[0],
		 v1.getV() + _points[1]);
}

Vector2 Vector2::operator-(Vector2 v1)
{
  return Vector2(_points[0] - v1.getU(),
		 _points[1] - v1.getV());
}

Vector2 Vector2::operator*(double num)
{
  return  Vector2(_points[0] * num,
		  _points[1] * num);
}

Vector2 Vector2::operator/(double num)
{
  return Vector2(_points[0] / num,
		 _points[1] / num);
}

void Vector2::set(double u, double v)
{
  _points[0] = u;
  _points[1] = v;
}

void Vector2::set(double *points)
{
  for (int i = 0; i < 2; i++)
    _points[i] = points[i];
}
