/* 
   Vector2.h

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#ifndef _VECTOR2_H_
#define _VECTOR2_H_

#include <iostream>
using namespace std;

class Vector2
{
 public:
  Vector2();
  Vector2(double u, double v);
  Vector2(double *points);
  virtual ~Vector2();

  // overloaded operators
  Vector2 operator+(Vector2 v1);
  Vector2 operator-(Vector2 v1);
  Vector2 operator*(double num);
  Vector2 operator/(double num);

  // Overloaded print
  friend ostream &operator<<(ostream &out, Vector2 &a);
  
  // setter functions
  void set(double u, double v);
  void set(double *points);
  void setU(double u) { _points[0] = u; }
  void setV(double v) { _points[1] = v; }

  // getter functions
  double *getVector() { return _points; }
  double getU() { return _points[0]; }
  double getV() { return _points[1]; }

 protected:
  double _points[2];
};

#endif
