/* 
   Vector3.h

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#ifndef _VECTOR3_H_
#define _VECTOR3_H_

#include <iostream>
using namespace std;

class Vector3
{
 public:
  Vector3();
  Vector3(double x, double y, double z);
  Vector3(double *points);
  virtual ~Vector3();

  // overloaded operators
  Vector3 operator+(Vector3 v1);
  Vector3 operator-(Vector3 v1);
  Vector3 operator*(double num);
  Vector3 operator/(double num);
  bool operator==(Vector3 v1);
  // Overloaded print
  friend ostream &operator<<(ostream &out, Vector3 &a);
  
  // setter functions
  void set(double x, double y, double z);
  void set(double *points);
  void setX(double x) { _points[0] = x; }
  void setY(double y) { _points[1] = y; }
  void setZ(double z) { _points[2] = z; }

  // getter functions
  double *getVector() { return _points; }
  double getX() { return _points[0]; }
  double getY() { return _points[1]; }
  double getZ() { return _points[2]; }

 protected:
  double _points[3];
};

#endif
