/* 
   VectorMath.h

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#ifndef _VECTORMATH_H_
#define _VECTORMATH_H_

#include <cmath>
#include "Vector3.h"

/**
 * Function to find the cross product 
 *  of two vectors
 */
Vector3 Cross(Vector3 v1, Vector3 v2);

/**
 * Normalize a vector
 */
Vector3 Normalize(Vector3 v1);

/**
 * Returns the Magnitude of a vector
 */
double Magnitude(Vector3 v1);

/**
 * Returns the normal of a triangle
 */
Vector3 FindNormal(Vector3 v1, Vector3 v2, Vector3 v3);

#endif
