/* 
   main.h

   IceCreamDrop 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#ifndef _MAIN_H_
#define _MAIN_H_

#include <iostream>
#include <vector>
#include <ctime>
#include <string>
using namespace std;

#include "SDL.h"
#include "SDL_ttf.h"

#include <GL/gl.h>
#include <GL/glu.h>

//#include <AL/al.h>
//#include <AL/alut.h>

#include "Camera.h"
#include "World.h"

bool initializeSDL();
bool createWindow(string windowName, bool fullScreen = false);
bool toggleFullScreen();
void initializeGL();
void resizeOpenGL();
void renderLoop();
void renderScene();
bool isExtensionSupported(string ext);
 
// globals
int videoFlags;
SDL_Surface *mainWindow = 0;
int g_width = 1024;
int g_height = 768;
int g_depth = 24;

#endif
